﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace ChangeDefaultEditor
{
    public partial class Form1 : Form
    {
        BindingList<MyValues> valuesList = new BindingList<MyValues>();
        BindingList<MyClass> list = new BindingList<MyClass>();

        public Form1()
        {
            InitializeComponent();

            radDataEntry1.EditorInitializing += radDataEntry1_EditorInitializing;
           
            for (int i = 0; i < 10; i++)
            {
                valuesList.Add(new MyValues("Value " + i));
                list.Add(new MyClass("Value " + i, Days.Mon));
            }

            BindingSource source = new BindingSource();
            source.DataSource = list;

            radBindingNavigator1.BindingSource = source;
            radDataEntry1.DataSource = source;
        }

        void radDataEntry1_EditorInitializing(object sender, Telerik.WinControls.UI.EditorInitializingEventArgs e)
        {
            if (e.Property.Name == "Str")
            {
                RadDropDownList radDropDownList1 = new RadDropDownList();

                radDropDownList1.DataSource = valuesList;
                radDropDownList1.ValueMember = "Value";
                radDropDownList1.DisplayMember = "Value";

                radDropDownList1.DropDownListElement.StretchHorizontally = true;

                e.Editor = radDropDownList1;
            }
        }
    }

    public enum Days
    {
        Sat,
        Sun,
        Mon,
        Tue,
        Wed,
        Thu,
        Fri
    }

    ;
    class MyValues
    {
        public string Value { get; set; }
        
        public MyValues(string value)
        {
            this.Value = value;
        }
    }

    class MyClass
    {
        public string Str { get; set; }

        public Days day { get; set; }

        public MyClass(string str, Days d)
        {
            this.Str = str;
            this.day = d;
        }
    }
}